unit MDIFrame;

interface

uses WinTypes, WinProcs, Classes, Graphics, Controls, Printers, SysUtils,
  Menus, MDIEdit, Dialogs, Forms, MRUList;

type
  TFrameForm = class(TForm)
    OpenFileDialog: TOpenDialog;
    MainMenu1: TMainMenu;
    Open1: TMenuItem;
    Window1: TMenuItem;
    Tile1: TMenuItem;
    Cascade1: TMenuItem;
    ArrangeIcons1: TMenuItem;
    FileExitSeparator: TMenuItem;
    MRUFileList: TMRUFileList;
    procedure NewChild(Sender: TObject);
    procedure OpenChild(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Tile1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure ArrangeIcons1Click(Sender: TObject);
    procedure MRUFileListMRUItemClick(Sender: TObject; AFilename: TFileName);
    procedure OnFormChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
end;

var
  FrameForm: TFrameForm;

implementation

{$R *.DFM}

procedure TFrameForm.NewChild(Sender: TObject);
var
  EditForm: TEditForm;
begin
  EditForm := TEditForm.Create(Application);
  EditForm.Show;
end;

procedure TFrameForm.OpenChild(Sender: TObject);
var
  EditForm: TEditForm;
begin
  if OpenFileDialog.Execute then
  begin
    EditForm := TEditForm.Create(Self);
    EditForm.Open(OpenFileDialog.Filename);
    EditForm.Show;
  end;
end;

procedure TFrameForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TFrameForm.Tile1Click(Sender: TObject);
begin
  Tile;
end;

procedure TFrameForm.Cascade1Click(Sender: TObject);
begin
  Cascade;
end;

procedure TFrameForm.ArrangeIcons1Click(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TFrameForm.MRUFileListMRUItemClick(Sender: TObject; AFilename: TFileName);
begin
  with TEditForm.Create(Self) do begin
    Memo1.Lines.LoadFromFile(AFileName);
    Caption := AFileName;
  end;
end;

procedure TFrameForm.OnFormChange(Sender: TObject);
begin
  if Application.Terminated then exit;
  if Screen.ActiveForm is TEditForm then
    MRUFileList.FileMenu := TEditForm(Screen.ActiveForm).FileExitSeparator
  else
    MRUFileList.FileMenu := FileExitSeparator;
end;


procedure TFrameForm.FormCreate(Sender: TObject);
begin
  Screen.OnActiveFormChange := OnFormChange;
end;

procedure TFrameForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  x: integer;
begin
  for x := MDIChildCount-1 downto 0 do
    MDIChildren[x].Close;
end;

end.



